ompi/mca/coll/sm/coll_sm_barrier.c File Reference.TH "ompi/mca/coll/sm/coll_sm_barrier.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/coll/sm/coll_sm_barrier.c \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'ompi/communicator/communicator.h'\fP
.br
\fC#include 'ompi/mca/coll/coll.h'\fP
.br
\fC#include 'opal/include/sys/atomic.h'\fP
.br
\fC#include 'coll_sm.h'\fP
.br

.SS "Functions"

.in +1c
.ti -1c
.RI "int \fBmca_coll_sm_barrier_intra\fP (struct ompi_communicator_t *comm)"
.br
.RI "\fIShared memory barrier. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Function Documentation"
.PP 
.SS "int mca_coll_sm_barrier_intra (struct ompi_communicator_t * comm)"
.PP
Shared memory barrier. 
.PP
Tree-based algorithm for a barrier: a fan in to rank 0 followed by a fan out using the barrier segments in the shared memory area.
.PP
There are 2 sets of barrier buffers -- since there can only be, at most, 2 outstanding barriers at any time, there is no need for more than this. The generalized in-use flags, control, and data segments are not used.
.PP
The general algorithm is for a given process to wait for its N children to fan in by monitoring a uint32_t in its barrier 'in' buffer. When this value reaches N (i.e., each of the children have atomically incremented the value), then the process atomically increases the uint32_t in its parent's 'in' buffer. Then the process waits for the parent to set a '1' in the process' 'out' buffer. Once this happens, the process writes a '1' in each of its children's 'out' buffers, and returns.
.PP
There's corner cases, of course, such as the root that has no parent, and the leaves that have no children. But that's the general idea. 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
